#SynSug_Enable=yes
#include <GUIConstants.au3>
#include <WindowsConstants.au3>
#include <GUIScrollBars.au3>
#include <WinAPIGdi.au3>
#include <APIGdiConstants.au3>
#include <EditConstants.au3>
#include <FontConstants.au3>
#include <Array.au3>
#include <GDIPlus.au3>
#include <ScreenCapture.au3>
#include <IE.au3>

Opt("ExpandVarStrings", True)
DllCall("User32.dll", "bool", "SetProcessDPIAware")

$avFonts = _WinAPI_EnumFontFamilies(Default, "", $ANSI_CHARSET, BitOR($DEVICE_FONTTYPE, $TRUETYPE_FONTTYPE), '@*', 1)
_ArraySort($avFonts)

$hMainWnd = GUICreate("FontShow", 600, 400, -1, -1, BitOR($WS_SIZEBOX, $WS_MAXIMIZEBOX, $WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU))
GUISetBkColor(0xffffff)
$cInputText = GUICtrlCreateInput("Hello World!", 10, 10, 250, 40)
GUICtrlSetFont(-1, fontHeightDPI(22))
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
$cInputSize = GUICtrlCreateInput("20", 270, 10, 70, 40, $ES_NUMBER)
GUICtrlSetFont(-1, fontHeightDPI(22))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
$cButtonRender = GUICtrlCreateButton("Rendern", 350, 10, 90, 40)
GUICtrlSetFont(-1, fontHeightDPI(16))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
$cButtonSave = GUICtrlCreateButton("Export", 450, 10, 90, 40)
GUICtrlSetFont(-1, fontHeightDPI(16))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
$cButtonHelp = GUICtrlCreateButton("?", 550, 10, 40, 40)
GUICtrlSetFont(-1, fontHeightDPI(16))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Dim $acButtonsJump[26]
For $c = 0 To 25
	$acButtonsJump[$c] = GUICtrlCreateLabel(Chr(65 + $c), 10 + $c * (580 / 26), 50, 580 / 26, 40, $SS_CENTER + $SS_CENTERIMAGE)
	GUICtrlSetColor(-1, 0x0000ff)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetFont(-1, fontHeightDPI(8.5), 800, 0, "Segoe UI")
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKLEFT + $GUI_DOCKHEIGHT + $GUI_DOCKWIDTH)
Next
$oIE = _IECreateEmbedded() ;dpi-awareness is not my problem, dear IE
$cIE = GUICtrlCreateObj($oIE, 10, 90, 580, 300)
GUICtrlSetResizing($cIE, $GUI_DOCKBORDERS)
_IENavigate($oIE, "about:blank")
refreshExamples()
GUISetState()

While True
	$iMsg = GUIGetMsg()
	Switch $iMsg
		Case -3
			Exit
		Case $cButtonRender
			refreshExamples()
		Case $cButtonSave
			exportExamples($oIE)
		Case $cButtonHelp
			displayHelpDialog()
		Case $acButtonsJump[0] To $acButtonsJump[25]
			$oSection = $oIE.document.getElementById("sec_" & Chr(65 + $iMsg - $acButtonsJump[0])) ;this is pretty cool, isn't it?
			If ObjName($oSection) == "HTMLAnchorElement" Then $oSection.scrollIntoView()
	EndSwitch
WEnd

Func fontHeightDPI($iPoints)
	Local $hDC, $iNewPoints
	$iNewPoints = $iPoints * _GDIPlus_GraphicsGetDPIRatio()[0]
	ConsoleWrite("DEBUG: " & $iPoints & " => " & $iNewPoints & @CRLF)
	Return $iNewPoints
EndFunc   ;==>fontHeightDPI

Func exportExamples($oIE)
	$sTempFile = @TempDir & "\fontshowrenderfile.html"
	$sOutFile = FileSaveDialog("FontShow", Default, "Portable Document Format (*.pdf)", 16, Default, $hMainWnd)
	If @error Then Return
	SplashTextOn("FontShow", "Export...")
	FileDelete($sTempFile)
	FileWrite($sTempFile, _IEDocReadHTML($oIE))
	$sCmdLine = '"' & @ScriptDir & '\wkhtmltopdf.exe" "' & $sTempFile & '" "' & $sOutFile & '"'
	RunWait($sCmdLine, @WorkingDir, @SW_HIDE)
	FileDelete($sTempFile)
	SplashOff()
EndFunc   ;==>IECreateScreenshot

Func displayHelpDialog()
#Tidy_Off
	Local $sText = <<<EOF
FontShow (c) @YEAR@ Sebastian Walter

FontShow steht unter der Microsoft Public License.

Genutzte Fremdsoftware:
- wkhtmltopdf.exe (www.wkhtmltopdf.org) unter der LGPLv3
EOF
#Tidy_On
	MsgBox(0, "FontShow", $sText)
EndFunc

Func refreshExamples()
	$sExampleText = GUICtrlRead($cInputText)
	$iExampleSize = GUICtrlRead($cInputSize)
#Tidy_Off
	$sHTML = <<<EOF
<style type="text/css">
.example {
	padding-left: 10px;
	border-top: 1px dashed black;
	background-color: #ffffff;
	page-break-inside: avoid;
}
.example-text {

}
.example-font {
	font-size: 20;
	font-family: "Segoe UI";
	font-style: italic;
	text-align: right;
}
.section {
	padding-left: 2px;
	display: block;
	background-color: #eeeeee;
	font-family: "Segoe UI";
	border-top: 1px solid black;
	font-size: $iExampleSize$;
}
</style>
EOF
#Tidy_On
	$sLastBeginning = -1
	For $i = 0 To UBound($avFonts) - 1
		$sCurrentBeginning = StringLeft($avFonts[$i][0], 1)
		If $sLastBeginning <> $sCurrentBeginning Then
			$sHTML &= "<a class='section' id='sec_" & $sCurrentBeginning & "'>" & $sCurrentBeginning & "</a>"
			$sLastBeginning = $sCurrentBeginning
		EndIf
		$sCurFont = $avFonts[$i][0]
#Tidy_Off
		$sHTML &= <<<EOF
<div class="example" style="font-family: $sCurFont$; font-size: $iExampleSize$">
	<div class="example-text">
		$sExampleText$
	</div>
	<div class="example-font">
		$sCurFont$
	</div>
</div>
EOF
#Tidy_On
	Next
	_IEDocWriteHTML($oIE, $sHTML)
EndFunc   ;==>refreshExamples



;######################################################################################################################################
; #FUNCTION# ====================================================================================================================
; Name ..........: _GDIPlus_GraphicsGetDPIRatio
; Description ...:
; Syntax ........: _GDIPlus_GraphicsGetDPIRatio([$iDPIDef = 96])
; Parameters ....: $iDPIDef             - [optional] An integer value. Default is 96.
; Return values .: None
; Author ........: UEZ
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/159612-dpi-resolution-problem/?hl=%2Bdpi#entry1158317
; Example .......: No
; ===============================================================================================================================
Func _GDIPlus_GraphicsGetDPIRatio($iDPIDef = 96)
	_GDIPlus_Startup()
	Local $hGfx = _GDIPlus_GraphicsCreateFromHWND(0)
	If @error Then Return SetError(1, @extended, 0)
	Local $aResult
	#forcedef $__g_hGDIPDll, $ghGDIPDll

	$aResult = DllCall($__g_hGDIPDll, "int", "GdipGetDpiX", "handle", $hGfx, "float*", 0)

	If @error Then Return SetError(2, @extended, 0)
	Local $iDPI = $aResult[2]
	Local $aresults[2] = [$iDPIDef / $iDPI, $iDPI / $iDPIDef]
	_GDIPlus_GraphicsDispose($hGfx)
	_GDIPlus_Shutdown()
	Return $aresults
EndFunc   ;==>_GDIPlus_GraphicsGetDPIRatio
