#SynSug_Enable=yes
#include <GUIConstants.au3>
#include <WindowsConstants.au3>
#include <GUIScrollBars.au3>
#include <WinAPIGdi.au3>
#include <APIGdiConstants.au3>
#include <EditConstants.au3>
#include <FontConstants.au3>
#include <Array.au3>
#include <GDIPlus.au3>
#include <ScreenCapture.au3>
#include <IE.au3>

Opt("ExpandVarStrings", True)
DllCall("User32.dll", "bool", "SetProcessDPIAware")

$avFonts = _WinAPI_EnumFontFamilies(Default, "", $ANSI_CHARSET, BitOR($DEVICE_FONTTYPE, $TRUETYPE_FONTTYPE), '@*', 1)
_ArraySort($avFonts)

$hMainWnd = GUICreate("FontShow", 600, 400, -1, -1, BitOR($WS_SIZEBOX, $WS_MAXIMIZEBOX, $WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU))
GUISetBkColor(0xffffff)
$cInputText = GUICtrlCreateInput("Hello World!", 10, 10, 250, 40)
GUICtrlSetFont(-1, fontHeightDPI(22))
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
$cInputSize = GUICtrlCreateInput("20", 270, 10, 70, 40, $ES_NUMBER)
GUICtrlSetFont(-1, fontHeightDPI(22))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
$cButtonRender = GUICtrlCreateButton("Rendern", 350, 10, 90, 40)
GUICtrlSetFont(-1, fontHeightDPI(16))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
$cButtonSave = GUICtrlCreateButton("Export", 450, 10, 90, 40)
GUICtrlSetFont(-1, fontHeightDPI(16))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)
$cButtonHelp = GUICtrlCreateButton("?", 550, 10, 40, 40)
GUICtrlSetFont(-1, fontHeightDPI(16))
GUICtrlSetResizing(-1, $GUI_DOCKRIGHT + $GUI_DOCKTOP + $GUI_DOCKWIDTH + $GUI_DOCKHEIGHT)

Dim $acButtonsJump[26]
For $c = 0 To 25
	$acButtonsJump[$c] = GUICtrlCreateLabel(Chr(65 + $c), 10 + $c * (580 / 26), 50, 580 / 26, 40, $SS_CENTER + $SS_CENTERIMAGE)
	GUICtrlSetColor(-1, 0x0000ff)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetFont(-1, fontHeightDPI(8.5), 800, 0, "Segoe UI")
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKLEFT + $GUI_DOCKHEIGHT + $GUI_DOCKWIDTH)
Next
$oIE = _IECreateEmbedded()
$cIE = GUICtrlCreateObj($oIE, 10, 90, 580, 300)
GUICtrlSetResizing($cIE, $GUI_DOCKBORDERS)
_IENavigate($oIE, "about:blank")
refreshExamples()
GUISetState()

While True
	$iMsg = GUIGetMsg()
	Switch $iMsg
		Case -3
			Exit
		Case $cButtonRender
			refreshExamples()
		Case $cButtonSave
			exportExamples($oIE)
		Case $cButtonHelp
			displayHelpDialog()
		Case $acButtonsJump[0] To $acButtonsJump[25]
			$oSection = $oIE.document.getElementById("sec_" & Chr(65 + $iMsg - $acButtonsJump[0]))
			If ObjName($oSection) == "HTMLAnchorElement" Then $oSection.scrollIntoView()
	EndSwitch
WEnd

Func fontHeightDPI($iPoints)
	Local $hDC, $iNewPoints
	$iNewPoints = $iPoints * _GDIPlus_GraphicsGetDPIRatio()[0]
	ConsoleWrite("DEBUG: " & $iPoints & " => " & $iNewPoints & @CRLF)
	Return $iNewPoints
EndFunc   ;==>fontHeightDPI

Func exportExamples($oIE)
	$sTempFile = @TempDir & "\fontshowrenderfile.html"
	$sOutFile = FileSaveDialog("FontShow", Default, "Portable Document Format (*.pdf)", 16, Default, $hMainWnd)
	If @error Then Return
	SplashTextOn("FontShow", "Export...")
	FileDelete($sTempFile)
	FileWrite($sTempFile, _IEDocReadHTML($oIE))
	$sCmdLine = '"' & @ScriptDir & '\wkhtmltopdf.exe" "' & $sTempFile & '" "' & $sOutFile & '"'
	RunWait($sCmdLine, @WorkingDir, @SW_HIDE)
	FileDelete($sTempFile)
	SplashOff()
EndFunc   ;==>exportExamples

Func displayHelpDialog()
#Tidy_Off
	Local $sText = "" & _
"FontShow (c) @YEAR@ Sebastian Walter" & @CRLF & _
"" & @CRLF & _
"FontShow steht unter der Microsoft Public License." & @CRLF & _
"" & @CRLF & _
"Genutzte Fremdsoftware:" & @CRLF & _
"- wkhtmltopdf.exe (www.wkhtmltopdf.org) unter der LGPLv3" & @CRLF & _
""
#Tidy_On
	MsgBox(0, "FontShow", $sText)
EndFunc   ;==>displayHelpDialog

Func refreshExamples()
	$sExampleText = GUICtrlRead($cInputText)
	$iExampleSize = GUICtrlRead($cInputSize)
#Tidy_Off
	$sHTML = "" & _
"<style type=""text/css"">" & @CRLF & _
".example {" & @CRLF & _
"	padding-left: 10px;" & @CRLF & _
"	border-top: 1px dashed black;" & @CRLF & _
"	background-color: #ffffff;" & @CRLF & _
"	page-break-inside: avoid;" & @CRLF & _
"}" & @CRLF & _
".example-text {" & @CRLF & _
"" & @CRLF & _
"}" & @CRLF & _
".example-font {" & @CRLF & _
"	font-size: 20;" & @CRLF & _
"	font-family: ""Segoe UI"";" & @CRLF & _
"	font-style: italic;" & @CRLF & _
"	text-align: right;" & @CRLF & _
"}" & @CRLF & _
".section {" & @CRLF & _
"	padding-left: 2px;" & @CRLF & _
"	display: block;" & @CRLF & _
"	background-color: #eeeeee;" & @CRLF & _
"	font-family: ""Segoe UI"";" & @CRLF & _
"	border-top: 1px solid black;" & @CRLF & _
"	font-size: $iExampleSize$;" & @CRLF & _
"}" & @CRLF & _
"</style>" & @CRLF & _
""
#Tidy_On
	$sLastBeginning = -1
	For $i = 0 To UBound($avFonts) - 1
		$sCurrentBeginning = StringLeft($avFonts[$i][0], 1)
		If $sLastBeginning <> $sCurrentBeginning Then
			$sHTML &= "<a class='section' id='sec_" & $sCurrentBeginning & "'>" & $sCurrentBeginning & "</a>"
			$sLastBeginning = $sCurrentBeginning
		EndIf
		$sCurFont = $avFonts[$i][0]
#Tidy_Off
		$sHTML &= "" & _
"<div class=""example"" style=""font-family: $sCurFont$; font-size: $iExampleSize$"">" & @CRLF & _
"	<div class=""example-text"">" & @CRLF & _
"		$sExampleText$" & @CRLF & _
"	</div>" & @CRLF & _
"	<div class=""example-font"">" & @CRLF & _
"		$sCurFont$" & @CRLF & _
"	</div>" & @CRLF & _
"</div>" & @CRLF & _
""
#Tidy_On
	Next
	_IEDocWriteHTML($oIE, $sHTML)
EndFunc   ;==>refreshExamples

















Func _GDIPlus_GraphicsGetDPIRatio($iDPIDef = 96)
	_GDIPlus_Startup()
	Local $hGfx = _GDIPlus_GraphicsCreateFromHWND(0)
	If @error Then Return SetError(1, @extended, 0)
	Local $aResult
	#forcedef $__g_hGDIPDll, $ghGDIPDll

	$aResult = DllCall($__g_hGDIPDll, "int", "GdipGetDpiX", "handle", $hGfx, "float*", 0)

	If @error Then Return SetError(2, @extended, 0)
	Local $iDPI = $aResult[2]
	Local $aresults[2] = [$iDPIDef / $iDPI, $iDPI / $iDPIDef]
	_GDIPlus_GraphicsDispose($hGfx)
	_GDIPlus_Shutdown()
	Return $aresults
EndFunc   ;==>_GDIPlus_GraphicsGetDPIRatio



; SYNSUG HELPER FUNCTIONS
#AutoIt3Wrapper_Run_AU3Check=N
#AutoIt3Wrapper_Run_Tidy=N

Func __SYNSUG_POSTINC(ByRef $int)
	$int += 1
	Return $int - 1
EndFunc   ;==>__SYNSUG_POSTINC

Func __SYNSUG_PREINC(ByRef $int)
	$int += 1
	Return $int
EndFunc   ;==>__SYNSUG_PREINC

Func __SYNSUG_POSTDEC(ByRef $int)
	$int -= 1
	Return $int + 1
EndFunc   ;==>__SYNSUG_POSTDEC

Func __SYNSUG_PREDEC(ByRef $int)
	$int -= 1
	Return $int
EndFunc   ;==>__SYNSUG_PREDEC

Func __SynSug_TraceEnterFunc($vFunc)
	Local $aTrace[2]
	ConsoleWrite("!TRACE")
	For $i = 1 To __SynSug_TraceLevel(0)
		ConsoleWrite("-")
	Next
	ConsoleWrite("> Entered function " & FuncName($vFunc) & "()." & @CRLF)
	__SynSug_TraceLevel(+1)
	$aTrace[0] = $vFunc
	$aTrace[1] = TimerInit()
	Return $aTrace
EndFunc   ;==>__SynSug_TraceEnterFunc

Func __SynSug_TraceLeaveFunc($aTrace, $vReturn)
	Local $iErr, $iExt
	$iErr = @error
	$iExt = @extended
	__SynSug_TraceLevel(-1)
	ConsoleWrite("!TRACE")
	For $i = 1 To __SynSug_TraceLevel(0)
		ConsoleWrite("-")
	Next
	ConsoleWrite("> Leaved function " & FuncName($aTrace[0]) & "() after " & TimerDiff($aTrace[1]) & " ms." & @CRLF)
	Return SetError($iErr, $iExt, $vReturn)
EndFunc   ;==>__SynSug_TraceLeaveFunc

Func __SynSug_TraceLevel($iChange)
	Local Static $iLevel = 0
	$iLevel += $iChange
	Return $iLevel
EndFunc   ;==>__SynSug_TraceLevel
